package com.jiuqi.db;

import java.util.Date;
import java.util.Calendar;

public abstract class DBFunction
{
    private static final String left_parenthesis = "(";
    private static final String right_parenthesis = ")";
    private static final String comma = ",";
    private static final String FUNC_NAME_ABS = "ABS";
    private static final String FUNC_NAME_ACOS = "ACOS";
    private static final String FUNC_NAME_ASIN = "ASIN";
    private static final String FUNC_NAME_ATAN = "ATAN";
    private static final String FUNC_NAME_ATAN2 = "ATAN2";
    private static final String FUNC_NAME_COS = "COS";
    private static final String FUNC_NAME_EXP = "EXP";
    private static final String FUNC_NAME_FLOOR = "FLOOR";
    private static final String FUNC_NAME_POWER = "POWER";
    private static final String FUNC_NAME_ROUND = "ROUND";
    private static final String FUNC_NAME_SIGN = "SIGN";
    private static final String FUNC_NAME_SIN = "SIN";
    private static final String FUNC_NAME_LOWER = "LOWER";
    private static final String FUNC_NAME_LTRIM = "LTRIM";
    private static final String FUNC_NAME_REPLACE = "REPLACE";
    private static final String FUNC_NAME_RTRIM = "RTRIM";
    private static final String FUNC_NAME_UPPER = "UPPER";
    private static final String FUNC_NAME_ASCII = "ASCII";
    private StringBuffer formatbuffer;
    
    public DBFunction() {
        this.formatbuffer = new StringBuffer();
    }
    
    protected String format(final String functionName, final String expression) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append("(");
        this.formatbuffer.append(expression);
        this.formatbuffer.append(")");
        return this.formatbuffer.toString();
    }
    
    protected String format(final String functionName, final String expression1, final String expression2) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append("(");
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(",");
        this.formatbuffer.append(expression2);
        this.formatbuffer.append(")");
        return this.formatbuffer.toString();
    }
    
    protected String format(final String functionName, final String expression1, final String expression2, final String expression3) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(functionName);
        this.formatbuffer.append("(");
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(",");
        this.formatbuffer.append(expression2);
        this.formatbuffer.append(",");
        this.formatbuffer.append(expression3);
        this.formatbuffer.append(")");
        return this.formatbuffer.toString();
    }
    
    protected String formatmidopt(final String expression1, final String operationSymbol, final String expression2) {
        this.formatbuffer.setLength(0);
        this.formatbuffer.append(expression1);
        this.formatbuffer.append(operationSymbol);
        this.formatbuffer.append(expression2);
        return this.formatbuffer.toString();
    }
    
    public abstract String strLinkSymbol();
    
    public abstract boolean supportEmptyString();
    
    public String abs(final String numeric_expression) {
        return this.format("ABS", numeric_expression);
    }
    
    public String acos(final String numeric_expression) {
        return this.format("ACOS", numeric_expression);
    }
    
    public String asin(final String numeric_expression) {
        return this.format("ASIN", numeric_expression);
    }
    
    public String atan(final String numeric_expression) {
        return this.format("ATAN", numeric_expression);
    }
    
    public String atan2(final String expression) {
        return this.format("ATAN2", expression);
    }
    
    public abstract String ceiling(final String p0);
    
    public String cos(final String numeric_expression) {
        return this.format("COS", numeric_expression);
    }
    
    public String exp(final String numeric_expression) {
        return this.format("EXP", numeric_expression);
    }
    
    public String floor(final String expression) {
        return this.format("FLOOR", expression);
    }
    
    public abstract String ln(final String p0);
    
    public abstract String log10(final String p0);
    
    public abstract String mod(final String p0, final String p1);
    
    public String power(final String numeric_expression1, final String numeric_expression2) {
        return this.format("POWER", numeric_expression1, numeric_expression2);
    }
    
    public String round(final String numeric_expression) {
        return this.round(numeric_expression, "0");
    }
    
    public String round(final String numeric_expression, final String int_expression) {
        return this.format("ROUND", numeric_expression, int_expression);
    }
    
    public String sign(final String numeric_expression) {
        return this.format("SIGN", numeric_expression);
    }
    
    public String sin(final String numeric_expression) {
        return this.format("SIN", numeric_expression);
    }
    
    public abstract String chr(final String p0);
    
    public abstract String pos(final String p0, final String p1);
    
    public abstract String left(final String p0, final String p1);
    
    public String lower(final String str_expression) {
        return this.format("LOWER", str_expression);
    }
    
    public String ltrim(final String str_expression) {
        return this.format("LTRIM", str_expression);
    }
    
    public String replace(final String source_str_expression, final String search_str_expression, final String replace_str_expression) {
        return this.format("REPLACE", source_str_expression, search_str_expression, replace_str_expression);
    }
    
    public abstract String right(final String p0, final String p1);
    
    public String rtrim(final String str_expression) {
        return this.format("RTRIM", str_expression);
    }
    
    public abstract String str(final String p0);
    
    public abstract String substr(final String p0, final String p1, final String p2);
    
    public String upper(final String str_expression) {
        return this.format("UPPER", str_expression);
    }
    
    public String ascii(final String char_expression) {
        return this.format("ASCII", char_expression);
    }
    
    public abstract String len(final String p0);
    
    public abstract String val(final String p0);
    
    public String date(final Calendar dateVal) {
        final Date d = dateVal.getTime();
        return this.date(d);
    }
    
    public abstract String date(final Date p0);
}
